<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
      integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO"
      crossorigin="anonymous"
    />

    <link rel="preconnect" href="https://fonts.googleapis.com" />
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
    <link
      href="https://fonts.googleapis.com/css2?family=DM+Serif+Display&family=Inter&family=Jost&family=Kaisei+Decol&family=Montserrat&family=Open+Sans:wght@300&display=swap"
      rel="stylesheet"
    />

    <style>
      .right-content {
        position: relative;
        display: flex;
        justify-content: center;
        align-items: center;
        padding-left: 2rem;
        padding-right: 0rem;
      }

      .image1 {
        background-image: url("images/patterns-geometricos.png");
        background-repeat: no-repeat;
        background-size: cover;
        width: 90%;
        padding-top: 95%;
        position: absolute;
      }

      .image2 {
        background-image: url("images/undraw_invest_88iw.png");
        background-repeat: no-repeat;
        width: 95%;
        padding-top: 80%;
        position: absolute;
      }

      .tittle {
        margin-top: 60px;
        text-align: center;
        color: #38d39f;
        font-family: Open Sans;
        font-size: 20px;
        font-style: normal;
        font-weight: 700;
        line-height: normal;
      }

      .form-label {
        color: #3f3d56;
        font-family: Open Sans;
        font-size: 12px;
        font-style: normal;
        font-weight: 400;
        line-height: normal;
      }

      .sign-up-button {
        border: 0px;
        width: 100%;
        padding: 3px 0px 7px 0px;
        margin-top: 20px;
        margin-bottom: 27px;
        border-radius: 3px;
        background: #38d39f;
        box-shadow: 0px 4px 4px 0px rgba(56, 211, 159, 0.19);

        color: #fff;
        font-family: Open Sans;
        font-size: 13px;
        font-style: normal;
        font-weight: 600;
        line-height: normal;
      }

      .by-signing {
        text-align: center;
        color: #3f3d56;
        font-family: Open Sans;
        font-size: 8px;
        font-style: normal;
        font-weight: 600;
        line-height: normal;
      }

      .by-signing-span {
        color: #38d39f;
        font-family: Open Sans;
        font-size: 8px;
        font-style: normal;
        font-weight: 600;
        line-height: normal;
      }

      .already {
        text-align: center;
        color: #3f3d56;
        font-family: Open Sans;
        font-size: 12px;
        font-style: normal;
        font-weight: 400;
        line-height: normal;
        margin-top: 57px;
        margin-bottom: 76px;
      }

      .already-span {
        color: #38d39f;
        font-family: Open Sans;
        font-size: 12px;
        font-style: normal;
        font-weight: 600;
        line-height: normal;
      }

      ::-webkit-input-placeholder {
        color: #9f9f9f;
        font-family: Open Sans;
        font-size: 10px;
        font-style: normal;
        font-weight: 400;
        line-height: normal;
      }
    </style>
  </head>
  <body>
    <div class="container-fluid p-4">
      <div class="row">
        <div class="col-md-6" style="padding-left: 4rem;">
          <div class="tittle">Create a free account</div>

          <form action="" id="loginForm">
            <div class="form-group">
              <label for="" class="form-label">Name</label>
              <input
                id="input-name"
                type="text"
                class="form-control"
                placeholder="Your name"
              />
            </div>
            <div class="form-group">
              <label for="" class="form-label">E-mail</label>
              <input
                id="input-email"
                type="text"
                class="form-control"
                placeholder="Your e-mail address"
              />
            </div>
            <div class="form-group">
              <label for="" class="form-label">Password</label>
              <input id="input-password" type="password" class="form-control" />
            </div>
            <div class="form-group">
              <label for="" class="form-label">Confirm Password</label>
              <input
                id="input-password-confirm"
                type="password"
                class="form-control"
              />
            </div>
            <button class="sign-up-button">Sign up</button>
          </form>

          <p class="by-signing">
            By signing up you agree to our
            <span class="by-signing-span">Terms of Service</span> and
            <span class="by-signing-span">Privacy Policy</span>
          </p>
          <p class="already">
            Already have an account? <span class="already-span">Login</span>
          </p>
        </div>
        <div class="col-md-6 right-content">
          <div class="image1"></div>
          <div class="image2"></div>
        </div>
      </div>
    </div>
  </body>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS =
      "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    var loginForm = document.getElementById("loginForm");
    loginForm.addEventListener("submit", (e) => {
      // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
      e.preventDefault();
      // Bước 0: Khởi tạo đối tượng thu thập
      var vObject = {
        name: "",
        email: "",
        password: "",
      };
      // Bước 1: thu thập dữ liệu
      getDataFromInput(vObject);
      // Bước 2: Kiểm tra dữ liệu thu thập
      var vCheck = validateData(vObject);
      // Bước 3: gọi API xử lý
      if (vCheck) {
        // create a request
        var vXmlHttpSignUp = new XMLHttpRequest();
        processAPI(vXmlHttpSignUp, vObject);
        vXmlHttpSignUp.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_CREATED
          ) {
            var vSignUpRespond = vXmlHttpSignUp.responseText;
            //B4: hiển thị dữ liệu
            hienThiDuLieu(vSignUpRespond);
          }
        };
      }
    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    function getDataFromInput(paramObject) {
      "use strict";
      var vNameInput = document.getElementById("input-name");
      var vEmailInput = document.getElementById("input-email");
      var vPassInput = document.getElementById("input-password");

      paramObject.name = vNameInput.value;
      paramObject.email = vEmailInput.value;
      paramObject.password = vPassInput.value;
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateData(paramObject) {
      "use strict";
      var vName = paramObject.name.trim(); // Chuẩn hóa dữ liệu
      var vEmail = paramObject.email.trim();
      var vPass = paramObject.password.trim();

      if (vName == "") {
        alert("Name is empty!");
        return false;
      }

      if (vEmail == "") {
        alert("Email is empty!");
        return false;
      }
      if (validateEmail(vEmail) == false) {
        alert("Email is invalid!");
        return false;
      }

      if (validatePassword(vPass) == false) {
        return false;
      }

      return true;
    }

    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(mail) {
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
        return true;
      }
      return false;
    }

    //hàm kiểm tra password
    //nếu trống hoặc không khớp confirm thì trả về false
    function validatePassword(pass) {
      var vPassConfirmInput = document.getElementById("input-password-confirm");
      var vPassCon = vPassConfirmInput.value.trim();

      if (pass == "") {
        alert("Password is empty!");
        return false;
      }

      if (pass != vPassCon) {
        alert("Password confirm is not correct!");
        return false;
      }

      return true;
    }

    // Hàm xử lý ajax API login
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject) {
      "use strict";
      var vData = JSON.stringify({
        fullname: paramObject.name,
        username: paramObject.name,
        password: paramObject.password,
      });

      paramRequest.open("POST", gBASE_URL, true);
      paramRequest.send(vData);
    }

    //hàm hiển thị dữ liệu
    function hienThiDuLieu(paramSignUpRespond) {
      console.log(paramSignUpRespond);
    }
  </script>
</html>
